import { browser } from "protractor";
import { ListPage } from "./list.po";
import { Navbar } from "./navbar.po";
import { PreferencesPage } from "./preferences.po";
import { CalculatorPage } from "./calculator.po";

describe("linked parameter in calculator with section - ", () => {
    let listPage: ListPage;
    let navBar: Navbar;
    let calcPage: CalculatorPage;
    let prefPage: PreferencesPage;

    beforeAll(async () => {
        listPage = new ListPage();
        navBar = new Navbar();
        calcPage = new CalculatorPage();
        prefPage = new PreferencesPage();
    });

    beforeEach(async () => {
        // disable evil option "empty fields on module creation"
        await prefPage.navigateTo();
        await prefPage.disableEvilEmptyFields();
        await browser.sleep(200);
    });

    it("modify section type", async () => {
        browser.manage().window().setPosition(2000, 30);

        // open first "parametric section" calculator
        await navBar.clickNewCalculatorButton();
        await listPage.clickMenuEntryForCalcType(2);
        await browser.sleep(200);

        // open second "parametric section" calculator
        await navBar.clickNewCalculatorButton();
        await listPage.clickMenuEntryForCalcType(2);
        await browser.sleep(200);

        // set Q parameter to linked mode
        const inputQ = calcPage.getInputById("Q");
        await calcPage.setParamMode(inputQ, "link");

        // change section type
        await calcPage.changeSelectValue(calcPage.getSelectById("select_section"), 3); // mode "parabolique"

        // check Q is still in linked mode
        expect(await calcPage.inputIsInLinkedMode(inputQ)).toBe(true);
    });
});
