#!/bin/bash

set -o errexit

# deploie l'appli sur le serveur $3 (user $2) dans le dossier $4 et met à jour le fichier index.html
# si la version est "prod"

if (( $# < 4 )); then
    echo "usage: $0 <version> <login> <server> <path>"
    exit 1
fi

VERSION="$1"
LOGIN="$2"
HOST="$3"
DIR="$4"

echo "$(basename $0): deploying version $VERSION in $LOGIN@$HOST:$DIR"

if [[ $VERSION == "prod" || $VERSION == "prod-devel" ]]; then
  # Copie de la branche production
  rsync -a --delete --exclude=cassiopee-releases -e "ssh -o StrictHostKeyChecking=no" dist/ ${LOGIN}@${HOST}:${DIR}/
  # Modification du dossier base href
  echo "updating index.html"
  if [[ $VERSION == "prod" ]]; then
    ssh $LOGIN@$HOST "sed -i 's:/cassiopee/stable/:/:g' $DIR/index.html"
  else
    ssh $LOGIN@$HOST "sed -i 's:/cassiopee/devel/:/:g' $DIR/index.html"
  fi
else
  # Copie de la branche / du tag
  rsync -a --delete --exclude=cassiopee-releases -e "ssh -o StrictHostKeyChecking=no" "dist/" "$LOGIN@$HOST:$DIR/$VERSION"
fi
