import { PressureLoss, Props, PressureLossType } from "jalhyd";
import { FormulaireFixedVar } from "./form-fixedvar";

/**
 * Formulaire pour la perte de charge
 */
export class FormulairePressureLoss extends FormulaireFixedVar {
    public preparseConfig(json: {}) {
        super.preparseConfig(json);

        // get pressure loss law select default value
        const dft: string = this.parseSelectDefaultValue(json, "select_pressurelosstype");
        this.defaultProperties["pressureLossType"] = PressureLossType[dft];
    }

    public initNub(props?: Props) {
        if (props === undefined) {
            props = new Props();
        }
        props.setPropValue("calcType", this.calculatorType);
        props.setPropValue("pressureLossType", this.defaultProperties["pressureLossType"]);
        super.initNub(props);
    }
}
